﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Services;

namespace Cmdjy.ws
{
    /// <summary>
    /// 万仕达，服务调用接口
    /// </summary>
    [WebService(Namespace = "http://Djy.wondersgroup.com/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    [System.ComponentModel.ToolboxItem(false)]
    // 若要允许使用 ASP.NET AJAX 从脚本中调用此 Web 服务，请取消注释以下行。 
    // [System.Web.Script.Services.ScriptService]
    public class WsdInterface:System.Web.Services.WebService
    {

        [WebMethod(Description = "获取代煎药处方信息")]
        public string GetData(WsdPrescriptionInfo info) {
            //获取数据

            //实例化WsdResult
            var result = new WsdRequest {

            };
            //编码：json串 +  加密信息
            return "Hello World";
        }
    }

    public class WsdRequest
    {
        /// <summary>
        /// 处方起始流水号。按照数字从1开始累加。返回结果包含此编号的处方。
        /// </summary>
        public string StartNo { get; set; }
        /// <summary>
        /// 最大本次获取的处方数量。根据客户网络和服务器配置情况自行调整
        /// </summary>
        public string MaxCount { get; set; }
    }

    public class WsdResult
    {
        /// <summary>
        /// 本次发送的处方数
        /// </summary>
        public int Count { get; set; }
        /// <summary>
        /// 是否还有处方未下载。不已历史是否下载为准，只计算此次下载后是否剩余未下载。
        /// </summary>
        public bool More { get; set; }
        /// <summary>
        /// 处方信息
        /// </summary>
        public List<WsdPrescriptionInfo> Prescriptions { get; set; }
    }

    /// <summary>
    /// HIS发送的处方信息
    /// </summary>
    public class WsdPrescriptionInfo
    {
        /// <summary>
        /// 处方流水号
        /// </summary>
        public int Id { get; set; }
        /// <summary>
        /// 处方类型
        /// </summary>
        public WsdPrescriptionType Type { get; set; }
        /// <summary>
        /// 如果为退方，这里传要退的处方流水号。此编号在下单应答消息中提供
        /// </summary>
        public string RawRecordId { get; set; }
        /// <summary>
        /// 药品明细数量
        /// </summary>
        public string DrugCount { get; set; }
        /// <summary>
        /// 处方备注
        /// </summary>
        public string Remark { get; set; }
        /// <summary>
        /// 带回病房 否
        /// </summary>
        public string TakeBack { get; set; }
        /// <summary>
        /// "操作类型": "煎药自取", or "操作类型": "煎药快递", or "操作类型": "配药快递"
        /// </summary>
        public string OpType { get; set; }
        /// <summary>
        /// 操作员
        /// </summary>
        public string OpUser { get; set; }
        /// <summary>
        /// 病区
        /// </summary>
        public string Area { get; set; }
        /// <summary>
        /// 病床号
        /// </summary>
        public string Bed { get; set; }
        /// <summary>
        /// 操作时间
        /// </summary>
        public string OpDatatime { get; set; }
        /// <summary>
        /// 处方号
        /// </summary>
        public string PrescriptionNo { get; set; }
        /// <summary>
        /// 处方日期
        /// </summary>
        public string PrescriptionDatatime { get; set; }
        /// <summary>
        /// 单位编号 医疗机构编号
        /// </summary>
        public string HosNo { get; set; }
        /// <summary>
        /// 医疗机构名称
        /// </summary>
        public string HosName { get; set; }
        /// <summary>
        /// 发票号
        /// </summary>
        public string InvoiceNo { get; set; }
        /// <summary>
        /// 病人编号
        /// </summary>
        public string PatientNo { get; set; }
        /// <summary>
        /// 病人卡号
        /// </summary>
        public string CardNo { get; set; }
        /// <summary>
        /// 科室名称
        /// </summary>
        public string DepName { get; set; }
        /// <summary>
        /// 病人年龄
        /// </summary>
        public string PatientAge { get; set; }
        /// <summary>
        /// 病人生日
        /// </summary>
        public string PatientBrithday { get; set; }
        /// <summary>
        /// 病人手机号码
        /// </summary>
        public string PatientMobile { get; set; }
        /// <summary>
        /// 病人电话
        /// </summary>
        public string PatientPhone { get; set; }
        /// <summary>
        /// 所在区县街道
        /// </summary>
        public string District { get; set; }
        /// <summary>
        /// 送货地址
        /// </summary>
        public string PostAddress { get; set; }
        /// <summary>
        /// 送货时间
        /// </summary>
        public string PostDatatime { get; set; }
        /// <summary>
        /// 贴数
        /// </summary>
        public string UseCount { get; set; }
        /// <summary>
        /// 病人性别
        /// </summary>
        public string PatientSex { get; set; }
        /// <summary>
        /// 病人姓名
        /// </summary>
        public string PatientName { get; set; }
        /// <summary>
        /// 医生姓名
        /// </summary>
        public string DoctorName { get; set; }
        /// <summary>
        /// 诊断
        /// </summary>
        public string Diagnosis { get; set; }
        /// <summary>
        /// 用法
        /// </summary>
        public string Usage { get; set; }
        /// <summary>
        /// 治疗号
        /// </summary>
        public string Zlh { get; set; }
        /// <summary>
        /// 收费序号
        /// </summary>
        public int Sfxh { get; set; }
        /// <summary>
        /// 收费费用序号
        /// </summary>
        public string Sffyxh { get; set; }
        /// <summary>
        /// 处方对应药品
        /// </summary>
        public List<WsdDrugInfo> Drugs { get; set; }
    }

    /// <summary>
    /// HIS发送的药品信息
    /// </summary>
    public class WsdDrugInfo
    {
        /// <summary>
        /// 药品流水号
        /// </summary>
        public int Id { get; set; }
        /// <summary>
        /// 处方流水号
        /// </summary>
        public string PrescriptionId { get; set; }
        /// <summary>
        /// "药品医保代码":"YP0306401000650",
        /// </summary>
        public string DrugNo { get; set; }
        /// <summary>
        /// 药品单价 0.085
        /// </summary>
        public string Price { get; set; }
        /// <summary>
        /// 单贴数量
        /// </summary>
        public string Count { get; set; }
        /// <summary>
        /// 单位 克
        /// </summary>
        public string Unit { get; set; }
        /// <summary>
        /// 单项总价
        /// </summary>
        public string Sum { get; set; }
        /// <summary>
        /// 规格  15.00000000
        /// </summary>
        public string DrugType { get; set; }
        /// <summary>
        /// 药品编码
        /// </summary>
        public string DrugLocalNo { get; set; }
        /// <summary>
        /// 药品名称
        /// </summary>
        public string DrugName { get; set; }
        /// <summary>
        /// 特殊要求
        /// </summary>
        public string Remark { get; set; }
    }

    /// <summary>
    /// 处方类型
    /// </summary>
    [Flags]
    public enum WsdPrescriptionType
    {
        /// <summary>
        /// 订单
        /// </summary>
        Order = 1,
        /// <summary>
        /// 撤销订单，退单
        /// </summary>
        CancelOrder = 2,
        /// <summary>
        /// 测试方。无效处方，测试用
        /// </summary>
        TestOrder = 4,
        /// <summary>
        /// 空处方，无此处方，调用方应该跳过该处方
        /// </summary>
        NullOrder = 8,
    }

}
